#ifndef __DEF_H__
#define __DEF_H__

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

typedef enum {true=1, false=0} bool;

enum {
  PRESS_BTN_UP = 0,
  PRESS_BTN_DOWN,
  PRESS_BTN_LEFT,
  PRESS_BTN_RIGHT,
  PRESS_BTN_A,
  PRESS_BTN_B,
  PRESS_BTN_X,
  PRESS_BTN_Y,
  PRESS_BTN_L,
  PRESS_BTN_R,
  PRESS_BTN_START,
  PRESS_BTN_SELECT,
  PRESS_BTN_MAX
};

enum {REP_NONE=0, REP_REPEAT=1, REP_RAW=2};
enum {LEFT_COL=0, RIGHT_COL=1};

typedef struct {
  int font_size;
  int font_height;
  int disp_line_max;
  char dfiler_path[200];
  char fontfile[200];
} global_option;

#define SCREEN_WIDTH  320
#define SCREEN_HEIGHT 240
#define SCREEN_BPP    16
#define WIDTH_MAX 155
#define HEIGHT_MAX 230

#define DEFAULT_FONT_PATH "/usr/local/share/VL-Gothic-Regular.ttf"
#define DISK_MOUNTPOINT "/boot"
#define ENTRY_NAME_MAX 256
#define ENTRY_NUM_MAX 500
#define PATHNAME_MAX 2048
#define TOKEN_LENGTH 50

#define REPEAT_DELAY 30
#define REPEAT_INTERVAL 2

#define FILE_COPY_BUFFER_SIZE (1024*1024)

extern global_option option;

extern SDL_Surface *gScreenSurface;
extern SDL_Surface *TextSurface;
extern TTF_Font *font;
extern TTF_Font *font_small;

extern bool button_to_process[PRESS_BTN_MAX];
extern int repeat_mode[PRESS_BTN_MAX];

extern SDL_Color color_white;
extern SDL_Color color_green;
extern SDL_Color color_red;
extern SDL_Color color_blue;
extern SDL_Color color_black;
extern SDL_Color color_gray;

#endif
